/* -*-text-*- */

/*
    Copyright (C) 1994  David W. Flater.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* Stuff for client connections */

#include "alibi.h"

static void
authdaemon (struct conlist *t, struct conlist **cons)
{
  /* Bozos telnetting to our ports might not bind their sockets */
  if (photogenesis ((int)(ntohs (*(u_short *)(&(t->addr.sa_data[0]))))))
  {
    printf ("Bozo on %s claimed to be a daemon.\n", t->name);
    fflush (stdout);
    bozoize (t);
  }
  /* Duplicate links and bozos will both get caught here */
  else if (duplink (cons, t->name))
  {
    printf ("Bozoing duplicate daemon link from %s\n", t->name);
    fflush (stdout);
    bozoize (t);
  }
  else
  {
    t->type = daemon;
    log_promo (t);
    text_sock_write (t, "Roger.\n");
    nc_add_column (t->name);        /* IMPORTANT!!! */
  }
}

/* Add another line to a datum. */
void
addline (struct conlist *t, char *text, char *bindata, long binlen)
{
  struct dobj *u;
  u = (struct dobj *) malloc (sizeof (struct dobj));
  if (!u)
    panic ("Couldn't malloc in addline", 1);
  u->next = (struct dobj *)0;
  u->text = strclone (text);
  u->binlen = binlen;
  if (binlen)
  {
    u->bindata = (char *) malloc (binlen);
    if (!(u->bindata))
      panic ("Couldn't malloc in addline", 1);
    memcpy (u->bindata, bindata, binlen);
  }
  else
    u->bindata = (char *)0;
  if (!(t->datum))
    t->datum = t->enddatum = u;
  else
  {
    /* Consing onto the end of a list =|-) */
    t->enddatum->next = u;
    t->enddatum = u;
  }
}

/* Service a client channel */
void
clienthandler (char *buf, struct conlist *t, struct conlist **cons)
{
  if (t->type != client)
    panic ("Wrong contype in clienthandler", 1);
  if (strncmp (buf, "I'm a daemon.", 13) == 0)
    authdaemon (t, cons);
  else if (strncmp (buf, "ereiamjh", 8) == 0)
  {
    t->type = wannabe;
    text_sock_write (t, "1 \033[1mGo away.\033[0m\n");
    log_promo (t);
  }
  else
  {
    char tbuf[namlen+80];
    long lenhack;
#ifdef logqueries
    {
      char *t;
      t = (char *) safmalloc (strlen(buf)+40);
      sprintf (t, "User query: '%s'", buf);
      timlog (t);
      free (t);
    }
#endif
    /* Construct a query */
    /* nopunct (buf); */
    /* djq = dejunk (buf, &lenhack); */
    /* djq = translate (djq, lenhack); */

    sprintf (tbuf, "0 Query path: %s", myhostname);
    addline (t, tbuf, (char *)0, 0l);
    sprintf (tbuf, "0 Start time: %lu", (unsigned long)(time((time_t *)0)));
    addline (t, tbuf, (char *)0, 0l);
    sprintf (tbuf, "0 Question from %lu at %s", t->snum, myhostname);
    addline (t, tbuf, (char *)0, 0l);
    {
      char *u;
      u = (char *) safmalloc (strlen(buf)+10);
      sprintf (u, "5 %s", buf);
      addline (t, u, NULL, 0l);
      free (u);
    }
    /* free (djq); */
    /* Count some things */
    qacc++;
    /* We assume that the last item is the query (see above). */
    {
      char *c;
      c = startoftext (t->enddatum);
      /* This is a horrible kluge.  Its main purpose is to filter out
       * pings.
       */
      if (c)
        if (*c == '(')
          noncracc++;
    }
    /* Now get rid of it */
    handle_query (t);
    free_dobj (t->datum); t->datum = t->enddatum = NULL;
    t->dmes = garbage;
  }
}
