/* -*-text-*- */

/*
    Copyright (C) 1994  David W. Flater.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * lcommand.c   Command channel server.
 *
 *  Don't put anything in here you don't want everybody using, because
 *  they will.  Use signals.c to hang useful but dangerous commands onto
 *  signals that you can send with a kill command.
 */

#include "alibi.h"

/* Interpret commands given over a command channel */
void
comhandler (char *buf, struct conlist *t, struct conlist **cons)
{
  struct conlist *u;
  if (t->type != command)
    panic ("Wrong contype in comhandler", 1);
  if (strncmp (buf, "quit", 4) == 0)
    delmark (t);
#if 0
  /* This is a dangerous command. */
  else if (strncmp (buf, "link", 4) == 0)
  {
    if (mklink (buf+4, cons, t))
      text_sock_write (t, "\nOK\nReady.\n");
    else
      text_sock_write (t, "\n?Link Error\nReady.\n");
  }
#endif
  else if (strncmp (buf, "list", 4) == 0)
  {
    char x[80];
    u = *cons;
    while (u != NULL)
    {
      sprintf (x, "%d %s\n", u->con, title (u->type));
      text_sock_write (t, x);
      u = u->next;
    }
    text_sock_write (t, "\nReady.\n");
  }
  else if (strncmp (buf, "hashstat", 8) == 0)
    nc_hashstat (t);
  else if (strncmp (buf, "qroutes", 7) == 0)
    list_qroutes (t);
  else if (strncmp (buf, "cache", 5) == 0)
    dump_cache (t);
  else
    text_sock_write (t, "\n?Syntax Error\nReady.\n");
}
