/* -*-text-*- */

/*
    Copyright (C) 1994  David W. Flater.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* Daemon authentication handshake */

#include "alibi.h"

void
nearhandler (char *buf, struct conlist *t, struct conlist **cons)
{
  if (t->type != near_daemon)
    panic ("Wrong contype in nearhandler", 1);
  if (!(strlen (buf)))
  {
    (t->blanks)++;
    if (t->blanks < 3)
      return;
    /* We've been bozo'd. */
    printf ("Bozo'd by %s.\n", t->name);
    fflush (stdout);
    delmark (t);
    return;
  }
  t->blanks = 0;
  if (strncmp (buf, "Yeah.", 5) == 0)
  {
#ifdef logcons
    printf ("%s is alive.\n", t->name);
    fflush (stdout);
#endif
    text_sock_write (t, "I'm a daemon.\n");
  } else if (strncmp (buf, "Roger.", 6) == 0)
  {
#ifdef logcons
    printf ("%s authorizes daemon link.\n", t->name);
    fflush (stdout);
#endif
    t->type = daemon;
    log_promo (t);
    nc_add_column (t->name);        /* IMPORTANT!!! */
    if (!(t->pingflag))
      panic ("Logic error with pingflag", 1);
    ping (t);
  }

  /* NUKEs should be ignored if this system is running production! */

  else if (strncmp (buf, "nuke", 4) == 0)
  {
#ifdef enable_nukes
    conlog (t, "Received NUKE from");
    nuke = 1;
    /* Attention:  This is a hack to avoid sending a shutdown back to */
    /* the site we got ours from.  Not that it would read it anyway. */
    delmark (t);
#else
    ;
#endif
  }
  else
  {
    printf ("%s is running off at the socket (%s).\n", t->name, buf);
    fflush (stdout);
  }
}
