#!/bin/sh
# Crude shell script to find your C compiler and what level of optimization it
# supports.  Some versions of gcc will accept any -Ox you specify without any
# errors or warnings whatsoever; if you don't like the result, edit makefile.
#
# Some compilers, like the SGI MIPS compiler, let you specify higher -O if you
# compile straight from .c to executable without going through the .o stage.
# Only the K&R makefile uses .o files.
#
echo ""
echo "Finding C compiler.  Please wait...."
echo ""
export C OPT NONSTDLIBS
if gcc -o setvars setvars.c; then
C=gcc
elif /usr/local/bin/gcc -o setvars setvars.c; then
C=/usr/local/bin/gcc
elif /usr/bin/gcc -o setvars setvars.c; then
C=/usr/bin/gcc
elif /bin/gcc -o setvars setvars.c; then
C=/bin/gcc
elif cc -o setvars setvars.c; then
C=cc
elif /usr/local/bin/cc -o setvars setvars.c; then
C=/usr/local/bin/cc
elif /usr/bin/cc -o setvars setvars.c; then
C=/usr/bin/cc
elif /bin/cc -o setvars setvars.c; then
C=/bin/cc
else
echo "ARRRRRRRRGH!  I HAVE FAILED!"
exit 1
fi
echo ""
echo "Finding max optimization.  Please wait...."
echo ""
mv setvars sv
rm -f delme
if $C -O5 -o setvars setvars.c > delme 2>&1 && ./sv < delme; then
OPT=-O5
else
rm -f delme
if $C -O4 -o setvars setvars.c > delme 2>&1 && ./sv < delme; then
OPT=-O4
else
rm -f delme
if $C -O3 -o setvars setvars.c > delme 2>&1 && ./sv < delme; then
OPT=-O3
else
rm -f delme
if $C -O2 -o setvars setvars.c > delme 2>&1 && ./sv < delme; then
OPT=-O2
else
rm -f delme
if $C -O -o setvars setvars.c > delme 2>&1 && ./sv < delme; then
OPT=-O
else
OPT=
fi
fi
fi
fi
fi
rm -f delme sv setvars
echo ""
echo "Done!  Using $C $OPT for compiles.  Change makefile if that annoys you."
echo ""
echo "Checking for nonstandard libraries...."
echo ""
if [ -f /usr/lib/libsocket.a ]; then
NONSTDLIBS=-lsocket
else
NONSTDLIBS=
fi
if [ -f /usr/lib/libnsl.a ]; then
NONSTDLIBS=${NONSTDLIBS}\ -lnsl
fi
make all2
